#include "libm.h"

/* k minimizes |exp(k ln2) - 2**k|, see cmath/__cexp.c */
static const uint32_t k = 1799;
static const double kln2 = 1246.97177782734161156;

/* exp(x)/2 for large x */
double __expo2(double x)
{
	double scale;

	/* note that k is odd and scale*scale overflows */
	INSERT_WORDS(scale, (0x3ff + k/2) << 20, 0);
	/* exp(x - k ln2) * 2**(k-1) */
	return exp(x - kln2) * scale * scale;
}
