#include "libm.h"

/* k minimizes |exp(k ln2) - 2**k|, see cmath/__cexpf.c */
static const uint32_t k = 235;
static const float kln2 = 162.88958740f;

/* expf(x)/2 for large x */
float __expo2f(float x)
{
	float scale;

	/* note that k is odd and scale*scale overflows */
	SET_FLOAT_WORD(scale, (0x7f + k/2) << 23);
	/* exp(x - k ln2) * 2**(k-1) */
	return expf(x - kln2) * scale * scale;
}
